#include "eeprom.h"

//==============================================================================
//    EEPROM
//     :
//      uint16 addr -  
//     :
//      uint8  data -  
//==============================================================================
uint8_t EEPROM_Read(uint16_t addr)
{
  while(BIT_TST(EECR, EE_WE));  //  
  EEAR = addr;                  //   
  BIT_SET(EECR, EE_RE);         //    
  EEAR = 0;                     //      (  EEPROM)
  return(EEDR);                 //  
}

//==============================================================================
//    EEPROM
//     :
//      uint16 addr -  
//      uint8  data -  
//==============================================================================
void EEPROM_Write(uint16_t addr, uint8_t data)
{
  uint8_t cSREG;

  while(BIT_TST(EECR, EE_WE));    //  
  EEAR = addr;                    //   
  EEDR = data;                    //      EEPROM
  cSREG = SREG;                   //   
  _CLI();                         //  
  BIT_SET(EECR, EE_MWE);           //    
  BIT_SET(EECR, EE_WE);            //   
  SREG = cSREG;                   //   
  EEAR = 0;                       //      (  EEPROM)
}
