//==============================================================================
//         HD44780
//==============================================================================

#include  "hd44780.h"

//==============================================================================
//  LCD-
//==============================================================================
static const uint8_t __flash HD44780_TableSymbol[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  0
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  1
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  2
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  3
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  4
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  5
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //  6
  0x06,0x09,0x09,0x06,0x00,0x00,0x00,0x00  //  7 -   
};

//==============================================================================
//     HD44780
//==============================================================================
static void HD44780_WriteCfg(uint8_t value)
{
  HD44780_WRITE_CFG(value);
  DELAY_US(100);
}

//==============================================================================
//     HD44780
//==============================================================================
static void HD44780_Write(uint8_t value)
{
  HD44780_WRITE0(value);
  DELAY_US(40);
}

//==============================================================================
//     HD44780
//==============================================================================
static void HD44780_WriteCmd(uint8_t cmd)
{
  HD44780_RS_0;                         //   
  HD44780_Write(cmd);
}

//==============================================================================
//     HD44780
//==============================================================================
static void HD44780_WriteData(uint8_t data)
{
  HD44780_RS_1;                         //   
  HD44780_Write(data);
}

//==============================================================================
//  
//==============================================================================
void HD44780_Init(void)
{
  HD44780_INIT;               //  
  
  DELAY_MS(15);
  HD44780_RS_0;               //   
  HD44780_WriteCfg(0x30);
  DELAY_MS(4);
  HD44780_WriteCfg(0x30);
  HD44780_WriteCfg(0x30);
  
#ifdef LCD_MODE_4
  HD44780_WriteCfg(0x20);
  HD44780_Write(0x28);
#endif

#ifdef LCD_MODE_8
  HD44780_Write(0x38);
#endif

  HD44780_Write(0x08);
  HD44780_Write(0x0C);
  HD44780_Write(0x01);
  DELAY_MS(1.6);
  HD44780_Write(0x06);
}

//==============================================================================
//     
//==============================================================================
void HD44780_LoadSymbol(void)
{
  HD44780_WriteCmd(0x40);       //    CGRAM (haracter generator RAM -   )
  for(uint8_t i = 0; i < 64; i++)
    HD44780_WriteData(HD44780_TableSymbol[i]);
  HD44780_WriteCmd(0x80);       //    DDRAM ( ASCII-,  )
}
