#ifndef LCD_HD44780_H
#define LCD_HD44780_H

#include <stdint.h>
#include "hd44780.h"

//---  LCD- ---------------------------------------------------
#define LCD_SYM_GRADUS                    0x07      //  " "
#define LCD_SYM_ARROW_UP                  0xD9      //  " "
#define LCD_SYM_ARROW_DOWN                0xDA      //  " "
    
#define LCD_POS(row, col)                 (((row) * (LCD_COL)) + (col))
    
#define LCD_COL                           40
#define LCD_ROW                           4
#define LCD_SIZE                          ((LCD_COL) * (LCD_ROW))
#define LCD_BLINK_BUF                     20

#define LCD_SET_CMD                       HD44780_RS_0
#define LCD_SET_DATA                      HD44780_RS_1
#define LCD_WRITE0(value)                 HD44780_WRITE0(value)
#define LCD_WRITE(value1, value2)         HD44780_WRITE(value1, value2)
#define LCD_WRITE_CMD(value)              HD44780_WRITE_CMD(value)
#define LCD_WRITE_DATA(value1, value2)    HD44780_WRITE_DATA(value1, value2)

void LCD_Init(void);

#endif  //  LCD_HD44780_H
