#ifndef MENU_H
#define MENU_H

#include <stdint.h>
#include "..\def_prog.h"
#include "..\device\lcd\lcd.h"
#include "..\module\display.h"
#include "..\module\edata.h"
#include "..\menu\menucfg.h"

enum { VAR_END, VAR_OVER };   //  /  /    

typedef struct
{
  void (* const show)(void);
  void (* const entry)(void);
  void (* const exit)(void);
  void (* const key[])(void);
} TMenu;

void MenuShow(void);
void MenuKey(uint8_t key);
void MenuSetMenu(uint8_t id);
void MenuNoEdit(void);

void MenuParamUpUI8(uint8_t *const param, uint8_t min, uint8_t max, uint8_t over);
void MenuParamDownUI8(uint8_t *const param, uint8_t min, uint8_t max, uint8_t over);
void MenuParamUpUI16(uint16_t *const param, uint16_t min, uint16_t max, uint8_t over);
void MenuParamDownUI16(uint16_t *const param, uint16_t min, uint16_t max, uint8_t over);
void MenuParamUpUI32(uint32_t *const param, uint32_t min, uint32_t max, uint8_t over);
void MenuParamDownUI32(uint32_t *const param, uint32_t min, uint32_t max, uint8_t over);
void MenuParamUpUI64(uint64_t *const param, uint64_t min, uint64_t max, uint8_t over);
void MenuParamDownUI64(uint64_t *const param, uint64_t min, uint64_t max, uint8_t over);

void MenuParamUpSI8(int8_t *const param, int8_t min, int8_t max, uint8_t over);
void MenuParamDownSI8(int8_t *const param, int8_t min, int8_t max, uint8_t over);
void MenuParamUpSI16(int16_t *const param, int16_t min, int16_t max, uint8_t over);
void MenuParamDownSI16(int16_t *const param, int16_t min, int16_t max, uint8_t over);
void MenuParamUpSI32(int32_t *const param, int32_t min, int32_t max, uint8_t over);
void MenuParamDownSI32(int32_t *const param, int32_t min, int32_t max, uint8_t over);
void MenuParamUpSI64(int64_t *const param, int64_t min, int64_t max, uint8_t over);
void MenuParamDownSI64(int64_t *const param, int64_t min, int64_t max, uint8_t over);

void stub(void);

#endif  //  MENU_H
