#ifndef LCD_HD44780_H
#define LCD_HD44780_H

#include <stdint.h>
#include "hd44780.h"

//---    ------------------------------------------------
//#define LCD0801
//#define LCD0802
//#define LCD1201
//#define LCD1202
//#define LCD1601
#define LCD1602
//#define LCD1604
//#define LCD2002
//#define LCD2004
//#define LCD3202
//#define LCD4002

//---  LCD- ---------------------------------------------------
#define LCD_SYM_GRADUS                0x07      //  " "
#define LCD_SYM_ARROW_UP              0xD9      //  " "
#define LCD_SYM_ARROW_DOWN            0xDA      //  " "

#define LCD_POS(row, col)   (((row) * (LCD_COL)) + (col))

#ifdef LCD0801
  #define LCD_COL       8
  #define LCD_ROW       1
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 1
#endif

#ifdef LCD0802
  #define LCD_COL       8
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 2
#endif

#ifdef LCD1201
  #define LCD_COL       12
  #define LCD_ROW       1
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 2
#endif

#ifdef LCD1202
  #define LCD_COL       12
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 3
#endif

#ifdef LCD1601
  #define LCD_COL       16
  #define LCD_ROW       1
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 2
#endif

#ifdef LCD1602
  #define LCD_COL       16
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 4
#endif

#ifdef LCD1604
  #define LCD_COL       16
  #define LCD_ROW       4
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 8
#endif

#ifdef LCD2002
  #define LCD_COL       20
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 5
#endif

#ifdef LCD2004
  #define LCD_COL       20
  #define LCD_ROW       4
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 10
#endif

#ifdef LCD3202
  #define LCD_COL       32
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 8
#endif

#ifdef LCD4002
  #define LCD_COL       40
  #define LCD_ROW       2
  #define LCD_SIZE      ((LCD_COL) * (LCD_ROW))
  #define LCD_BLINK_BUF 10
#endif

#define LCD_SET_CMD                 HD44780_RS_0
#define LCD_SET_DATA                HD44780_RS_1
#define LCD_WRITE(value)            HD44780_WRITE(value)
//#define LCD_WRITE_CMD(value)    HD44780_WRITE_CMD(value)
//#define LCD_WRITE_DATA(value)   HD44780_WRITE_DATA(value)

void LCD_Init(void);

#endif  //  LCD_HD44780_H
