//==============================================================================
//
//==============================================================================
#include "..\module\menu.h"

extern volatile uint8_t   Flags_0;                        //  
extern volatile uint8_t   DisplayBlink[];                 //     
extern          uint16_t  Param_2;                        //  2
extern          int16_t   Param_3;                        //  3
extern          uint16_t  EditValueUI16;                  //  
extern          int16_t   EditValueSI16;                  //  
extern          uint8_t   MenuParamHor;                   //    ()

extern const uint8_t __flash MsgParam_23[];               //   

//==============================================================================
//  
//==============================================================================
static void show(void)
{
  uint16_t *p2;
  int16_t *p3;

  ShowTextF(2, MsgParam_23);
  if(!EDIT)
  {
    p2 = &Param_2;
    p3 = &Param_3;
  }
  else
  {
    p2 = &EditValueUI16;
    p3 = &EditValueSI16;
  }
  ShowTextValueUI16(16, "K2=", *p2, 3, ' ');
  ShowTextValueSI16(25, "K3=", *p3, 3, ' ');
}

//==============================================================================
//     
//==============================================================================
static void entry(void)
{
}

//==============================================================================
//     
//==============================================================================
static void exit(void)
{
}

//==============================================================================
//   ""
//==============================================================================
static void up(void)
{
  if(EDIT)
  {
    switch(MenuParamHor)
    {
      case 0: MenuParamUpUI16(&EditValueUI16, MIN_PARAM_2, MAX_PARAM_2, VAR_END); break;
      case 1: MenuParamUpSI16(&EditValueSI16, MIN_PARAM_3, MAX_PARAM_3, VAR_OVER); break;
    }
  }
}

//==============================================================================
//   ""
//==============================================================================
static void down(void)
{
  if(EDIT)
  {
    switch(MenuParamHor)
    {
      case 0: MenuParamDownUI16(&EditValueUI16, MIN_PARAM_2, MAX_PARAM_2, VAR_END); break;
      case 1: MenuParamDownSI16(&EditValueSI16, MIN_PARAM_3, MAX_PARAM_3, VAR_OVER); break;
    }
  }
}

//==============================================================================
//   ""
//==============================================================================
static void param(void)
{
  if(!EDIT)
    MenuSetMenu(MENU_SET_PARAM_456789);
  else
  {
    MenuParamUpUI8(&MenuParamHor,0,1,VAR_OVER);
    switch(MenuParamHor)
    {
      case  0: LCD_SET_BLINK(19,3); break;
      case  1: LCD_SET_BLINK(29,3); break;
    }
  }
}

//==============================================================================
//   ""
//==============================================================================
static void enter(void)
{
  if(!EDIT)
  {
    EditValueUI16 = Param_2;
    EditValueSI16 = Param_3;
    LCD_SET_BLINK(19,3);
    MenuParamHor = 0;
    SET_EDIT;                                       //    
  }
  else
  {
    Param_2 = EditValueUI16;
    Param_3 = EditValueSI16;
    EDATA_WRITE(param_2, &Param_2);
    EDATA_WRITE(param_3, &Param_3);
    MenuNoEdit();
  }
}

//==============================================================================
//const TMenu __flash Menu... = {show, entry, exit, {up, down, param, enter}};
const TMenu __flash MenuSetParam23 = {show, entry, exit, {up, down, param, enter}};

