//==============================================================================
//
//==============================================================================
#include "..\module\menu.h"

extern volatile uint8_t Flags_0;                          //  
extern volatile uint8_t DisplayBlink[];                   //     
extern          uint8_t Param_4[];                        //  4-9
extern          uint8_t EditValueInt8[];                  //  
extern          uint8_t MenuParamHor;                     //    ()

//==============================================================================
//
//==============================================================================
static void display_flash(void)
{
  switch(MenuParamHor)
  {
    case  0: LCD_SET_BLINK(3,1);  break;
    case  1: LCD_SET_BLINK(9,1);  break;
    case  2: LCD_SET_BLINK(15,1); break;
    case  3: LCD_SET_BLINK(19,1); break;
    case  4: LCD_SET_BLINK(25,1); break;
    case  5: LCD_SET_BLINK(31,1); break;
  }
}

//==============================================================================
//  
//==============================================================================
static void show(void)
{
  uint8_t *p;
  
  if(!EDIT) p = Param_4;
  else      p = EditValueInt8;
  ShowTextValueUI8(0 , "K4=", *p++, 1, ' ');
  ShowTextValueUI8(6 , "K5=", *p++, 1, ' ');
  ShowTextValueUI8(12, "K6=", *p++, 1, ' ');
  ShowTextValueUI8(16, "K7=", *p++, 1, ' ');
  ShowTextValueUI8(22, "K8=", *p++, 1, ' ');
  ShowTextValueUI8(28, "K9=", *p,   1, ' ');
}

//==============================================================================
//     
//==============================================================================
static void entry(void)
{
}

//==============================================================================
//     
//==============================================================================
static void exit(void)
{
}

//==============================================================================
//   ""
//==============================================================================
static void up(void)
{
  if(EDIT)
    MenuParamUpUI8(&EditValueInt8[MenuParamHor], MIN_PARAM_4, MAX_PARAM_4, VAR_OVER);
}

//==============================================================================
//   ""
//==============================================================================
static void down(void)
{
  if(EDIT)
    MenuParamDownUI8(&EditValueInt8[MenuParamHor], MIN_PARAM_4, MAX_PARAM_4, VAR_OVER);
}

//==============================================================================
//   ""
//==============================================================================
static void param(void)
{
  if(!EDIT)
    MenuSetMenu(MENU_SET_DEFAULT);
  else
  {
    MenuParamUpUI8(&MenuParamHor,0,5,VAR_OVER);
    display_flash();
  }
}

//==============================================================================
//   ""
//==============================================================================
static void enter(void)
{
  if(!EDIT)
  {
    for(uint8_t i=0; i<PARAM_4_MAX; i++)
      EditValueInt8[i] = Param_4[i];
    display_flash();
    MenuParamHor = 0;
    SET_EDIT;                                       //    
  }
  else
  {
    for(uint8_t i=0; i<PARAM_4_MAX; i++)
      Param_4[i] = EditValueInt8[i];
    EDATA_WRITE(param_4, &Param_4);
    MenuNoEdit();
  }
}

//==============================================================================
//const TMenu __flash Menu... = {show, entry, exit, {up, down, left, right, enter, escape}};
const TMenu __flash MenuSetParam456789 = {show, entry, exit, {up, down, param, enter}};

