#ifndef DISPLAY_H
#define DISPLAY_H

#include <stdint.h>
#include  "..\system.h"
#include  "..\misc.h"
#include  "..\device\lcd\lcd.h"

void DisplayUpdate(void);
void DisplayClear(void);
uint8_t ShowText(uint8_t pos, const uint8_t *s);
uint8_t ShowTextF(uint8_t pos, const uint8_t __flash *s);
void ShowChar(uint8_t pos, uint8_t ch);
void ShowValueUI8(uint8_t pos, uint8_t value, uint8_t width, uint8_t ch);
void ShowValueUI16(uint8_t pos, uint16_t value, uint8_t width, uint8_t ch);
void ShowValueSI8(uint8_t pos, int8_t value, uint8_t width, uint8_t ch);
void ShowValueSI16(uint8_t pos, int16_t value, uint8_t width, uint8_t ch);
void ShowTextValueUI8(uint8_t pos, const uint8_t *s, uint8_t value, uint8_t width, uint8_t ch);
void ShowTextValueUI16(uint8_t pos, const uint8_t *s, uint16_t value, uint8_t width, uint8_t ch);
void ShowTextValueSI8(uint8_t pos, const uint8_t *s, int8_t value, uint8_t width, uint8_t ch);
void ShowTextValueSI16(uint8_t pos, const uint8_t *s, int16_t value, uint8_t width, uint8_t ch);
void ShowTextFValueUI8(uint8_t pos, const uint8_t __flash *s, uint8_t value, uint8_t width, uint8_t ch);
void ShowTextFValueUI16(uint8_t pos, const uint8_t __flash *s, uint16_t value, uint8_t width, uint8_t ch);
void ShowTextFValueSI8(uint8_t pos, const uint8_t __flash *s, int8_t value, uint8_t width, uint8_t ch);
void ShowTextFValueSI16(uint8_t pos, const uint8_t __flash *s, int16_t value, uint8_t width, uint8_t ch);
void ShowDate(uint8_t pos, uint16_t value);
void ShowTime(uint8_t pos, uint16_t value);

#endif
