#ifndef EDATA_H
#define EDATA_H

#include <stdint.h>
#include <stddef.h>
#include "..\system.h"
#include "..\def_prog.h"
#include "..\device\eeprom.h"

//-----   EEPROM -------------------------------------------
#pragma pack(push,1)  //    1 
typedef struct
{
  uint8_t   no_use;   //  eeprom  AVR
  uint8_t   param_1;
  uint16_t  param_2;
  int16_t   param_3;
  uint8_t   param_4[PARAM_4_MAX];
} EData;
#pragma pack(pop)     //   
//------------------------------------------------------------------------------

#define EDATA_READ(M, D)    EData_Read(offsetof(EData, M), sizeof(((EData *)0)->M), D);
#define EDATA_WRITE(M, D)   EData_Write(offsetof(EData, M), sizeof(((EData *)0)->M), D);

#define EDATA_RESTORE_UI8(M, min, max, def)   EData_RestoreUI8(offsetof(EData, M), min, max, def);
#define EDATA_RESTORE_UI16(M, min, max, def)  EData_RestoreUI16(offsetof(EData, M), min, max, def);
#define EDATA_RESTORE_SI8(M, min, max, def)   EData_RestoreSI8(offsetof(EData, M), min, max, def);
#define EDATA_RESTORE_SI16(M, min, max, def)  EData_RestoreSI16(offsetof(EData, M), min, max, def);

void EData_Read(uint32_t offset, uint32_t count, void *dest);
void EData_Write(uint32_t offset, uint32_t count, void * dest);

uint8_t EData_RestoreUI8(uint32_t offset, uint8_t min, uint8_t max, uint8_t def);
uint16_t EData_RestoreUI16(uint32_t offset, uint16_t min, uint16_t max, uint16_t def);
int8_t EData_RestoreSI8(uint32_t offset, int8_t min, int8_t max, int8_t def);
int16_t EData_RestoreSI16(uint32_t offset, int16_t min, int16_t max, int16_t def);

#endif  //  EDATA_H