//==============================================================================
//   ,         HD44780
//    - LCD_SET_BLINK(5,3)
//                    | |
//                    | 3 -     
//                    5 -     
//==============================================================================

#ifndef LCD_BLINK_H
#define LCD_BLINK_H

#include <stdint.h>

#define LCD_SET_BLINK_WIDTH(width)  (((width) == 1) ? 0x01 :    \
                                    (((width) == 2) ? 0x03 :    \
                                    (((width) == 3) ? 0x07 :    \
                                    (((width) == 4) ? 0x0F :    \
                                    (((width) == 5) ? 0x1F :    \
                                    (((width) == 6) ? 0x3F :    \
                                    (((width) == 7) ? 0x7F :    \
                                    (((width) == 8) ? 0xFF :    \
                                      0xFF))))))))

#define LCD_SET_BLINK_BYTE(byte, pos, width)  ((!(width)) ? 0x00 :                                                                          \
                                              ((((byte) > ((pos) >> 3)) && ((byte) < (((pos) + (width) - 1) >> 3))) ? 0xFF :                    \
                                              ((((byte) != ((pos) >> 3)) && ((byte) != (((pos) + (width) - 1) >> 3))) ? 0x00 :                  \
                                              (((byte) == ((pos) >> 3)) ? (uint8_t)(LCD_SET_BLINK_WIDTH(width) << ((pos) & 7)) :                \
                                              (((byte) == (((pos) + (width)) >> 3)) ? (LCD_SET_BLINK_WIDTH((((width) + (pos) - 1) & 7) + 1)) :  \
                                                0xFF)))))

#if (LCD_BLINK_BUF == 1)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                    }
#endif

#if (LCD_BLINK_BUF == 2)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                      DisplayBlink[1] = LCD_SET_BLINK_BYTE(1, (pos), (width));  \
                                    }
#endif

#if (LCD_BLINK_BUF == 4)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                      DisplayBlink[1] = LCD_SET_BLINK_BYTE(1, (pos), (width));  \
                                      DisplayBlink[2] = LCD_SET_BLINK_BYTE(2, (pos), (width));  \
                                      DisplayBlink[3] = LCD_SET_BLINK_BYTE(3, (pos), (width));  \
                                    }
#endif

#if (LCD_BLINK_BUF == 5)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                      DisplayBlink[1] = LCD_SET_BLINK_BYTE(1, (pos), (width));  \
                                      DisplayBlink[2] = LCD_SET_BLINK_BYTE(2, (pos), (width));  \
                                      DisplayBlink[3] = LCD_SET_BLINK_BYTE(3, (pos), (width));  \
                                      DisplayBlink[4] = LCD_SET_BLINK_BYTE(4, (pos), (width));  \
                                    }
#endif

#if (LCD_BLINK_BUF == 8)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                      DisplayBlink[1] = LCD_SET_BLINK_BYTE(1, (pos), (width));  \
                                      DisplayBlink[2] = LCD_SET_BLINK_BYTE(2, (pos), (width));  \
                                      DisplayBlink[3] = LCD_SET_BLINK_BYTE(3, (pos), (width));  \
                                      DisplayBlink[4] = LCD_SET_BLINK_BYTE(4, (pos), (width));  \
                                      DisplayBlink[5] = LCD_SET_BLINK_BYTE(5, (pos), (width));  \
                                      DisplayBlink[6] = LCD_SET_BLINK_BYTE(6, (pos), (width));  \
                                      DisplayBlink[7] = LCD_SET_BLINK_BYTE(7, (pos), (width));  \
                                    }
#endif

#if (LCD_BLINK_BUF == 10)
  #define LCD_SET_BLINK(pos, width) {                                                           \
                                      DisplayBlink[0] = LCD_SET_BLINK_BYTE(0, (pos), (width));  \
                                      DisplayBlink[1] = LCD_SET_BLINK_BYTE(1, (pos), (width));  \
                                      DisplayBlink[2] = LCD_SET_BLINK_BYTE(2, (pos), (width));  \
                                      DisplayBlink[3] = LCD_SET_BLINK_BYTE(3, (pos), (width));  \
                                      DisplayBlink[4] = LCD_SET_BLINK_BYTE(4, (pos), (width));  \
                                      DisplayBlink[5] = LCD_SET_BLINK_BYTE(5, (pos), (width));  \
                                      DisplayBlink[6] = LCD_SET_BLINK_BYTE(6, (pos), (width));  \
                                      DisplayBlink[7] = LCD_SET_BLINK_BYTE(7, (pos), (width));  \
                                      DisplayBlink[8] = LCD_SET_BLINK_BYTE(8, (pos), (width));  \
                                      DisplayBlink[9] = LCD_SET_BLINK_BYTE(9, (pos), (width));  \
                                    }
#endif

#endif  //  LCD_BLINK_H
