#ifndef REG_IO_H
#define REG_IO_H

#include "..\system.h"

#define REG_IN_PIN      PINA

#define REG_DATA_PORT   PORTC

#define PIN_REG_CS_0    B, 3
#define PIN_REG_CS_1    B, 4
#define PIN_REG_CS_2    B, 5
#define PIN_REG_CS_3    B, 6
#define PIN_REG_OE      B, 7

#define REG_INIT        {                                             \
                          PIN_CFG(PIN_REG_CS_0, PIN_OUT,  PIN_CLR);   \
                          PIN_CFG(PIN_REG_CS_1, PIN_OUT,  PIN_CLR);   \
                          PIN_CFG(PIN_REG_CS_2, PIN_OUT,  PIN_SET);   \
                          PIN_CFG(PIN_REG_CS_3, PIN_OUT,  PIN_SET);   \
                          PIN_CFG(PIN_REG_OE,   PIN_IN,   PIN_CLR);   \
                        }

#define REG_OUT_1_ON    PIN_SET(PIN_REG_CS_0)
#define REG_OUT_1_OFF   PIN_CLR(PIN_REG_CS_0)

#define REG_OUT_2_ON    PIN_SET(PIN_REG_CS_1)
#define REG_OUT_2_OFF   PIN_CLR(PIN_REG_CS_1)

#define REG_IN_1_ON     PIN_CLR(PIN_REG_CS_2)
#define REG_IN_1_OFF    PIN_SET(PIN_REG_CS_2)

#define REG_IN_2_ON     PIN_CLR(PIN_REG_CS_3)
#define REG_IN_2_OFF    PIN_SET(PIN_REG_CS_3)

#define REG_OE_ON       PIN_OUT(PIN_REG_OE)
#define REG_OE_OFF      PIN_IN(PIN_REG_OE)

#define REG_DELAY       DELAY_NS(250);

#define REG_IN_MASK_1   0x00                    //  
#define REG_IN_MASK_2   0x00                    //  
#define REG_OUT_MASK_1  0x00                    //  
#define REG_OUT_MASK_2  0x00                    //  

void RegIO_Init(void);

#endif  //  REG_IO_H
