#include <stdint.h>
#include "system.h"
#include "def_prog.h"
#include "device\bell.h"
#include "device\lcd\lcd_hd44780.h"
#include "device\reg_io.h"
#include "module\alg.h"
#include "module\edata.h"
#include "module\menu.h"
#include "menu\menucfg.h"

extern   uint8_t  MenuID;                  //   

volatile uint8_t  Flags_0;                 //  
volatile uint8_t  Key;                     //   
volatile uint8_t  RegIn_1;                 //  1  
volatile uint8_t  RegIn_2;                 //  2  
volatile uint8_t  RegOut_1;                //  1  
volatile uint8_t  RegOut_2;                //  2  
         uint8_t  CountPass;               //   
         uint8_t  Param_1;                 //  1
         uint16_t Param_2;                 //  2
         int16_t  Param_3;                 //  3
         uint8_t  TimeReturn;              //      

//==============================================================================
//   
//==============================================================================
static void InitHardware(void)
{
  RegIO_Init();                                   //   /
  Bell_Init();                                    //  
  LCD_Init();                                     //  
  TIMER_1MS_START;                                //    1 
}

//==============================================================================
//  
//==============================================================================
static void InitVariable(void)
{
  RESET_RECOUNT_1S;                               //   " 1s"
  RESET_RECOUNT_250MS;                            //   " 250ms"
  RESET_KEY_PRESS;                                //   " "
  REG_OE_ON;                                      //      
}

//==============================================================================
//   (Reset)
//==============================================================================
void main(void)
{
  InitHardware();                                           //  
  __enable_interrupt();                                     //  
//  MenuSetMode(MENU_VERSION);                                //      
//  MenuShow();                                               //    -//-
  _SEI();                                                   //  
  InitVariable();                                           //  
  MenuSetMenu(MENU_DEFAULT);                                //   
  WDR_ENABLED;                                              //   

  while(1)                                                  //   
  {
    _WDR();                                                 //   
    if(RECOUNT_250MS)                                       //  250  ,
    {                                                       // 
      Monitoring();                                         // : 
      Control();                                            // : 
      RESET_RECOUNT_250MS;                                  //   " 250ms"
    }

    if(RECOUNT_1S)                                          //  1  ,
    {                                                       // 
//-----       Default -------------------------
      if(MenuID != MENU_DEFAULT)                            //     ,
      {                                                     // 
        if(!TimeReturn) MenuSetMenu(MENU_DEFAULT);          //     ( )
        else            TimeReturn--;                       //   
      }
      RESET_RECOUNT_1S;                                     //   " 1s"
    }
//-----   ---------------------------------------------------
    if(KEY_PRESS)                                           //   ,
    {                                                       // 
      TimeReturn = TIMEOUT_RETURN;                          //       
      MenuKey(Key);                                         //    
      RESET_KEY_PRESS;                                      //    
    }
    MenuShow();
  }
}
